//SWRFlagger bot
// by Mine GO BOOM

#include "SWRFlagger.h"

extern "C" __declspec (dllexport) void CALLBACK DATABOT_Cmd(BOT_INFO *bi) {
	BOT_NAMES bn[MAX_DLLS];
	strcpy(bi->DllInfo->HeaderVersion,BOT_HEADER_VERSION);
	bi->DllInfo->MaxBotsAllowed=LoadBotName(bn);
	strcpy(bi->DllInfo->Name,"SWRFlagger");
	strcpy(bi->DllInfo->Version,"0.02");
	strcpy(bi->DllInfo->Info,"Designed for SWR to pickup flags that are dropped outside. Will load invalid flag coords from a bmp file");
	strcpy(bi->DllMaker->Name,"Mine GO BOOM");
	strcpy(bi->DllMaker->Email,"murphyj@cvn.net");
}

extern "C" __declspec (dllexport) void CALLBACK WEBBOT_Cmd(BOT_WEB *bw,BOT_MSG2 *bn) {
}

extern "C" __declspec (dllexport) void CALLBACK CEBOT_Cmd(BOT_CMD *bc,BOT_MSG *bm) {
	switch (bc->Cmd) {
	case BOTCMD_Init:
		if (bm->SendDataSize(bc,sizeof(SWR_DATA))) {
			bm->SendShutdown(bc);
		} else {
			FindEmptyName(bc,bm);
		}
		break;
	case BOTCMD_EnterZone:
		if (bc->Data1 || bc->Data2) {
			bm->SendShutdown(bc);
		} else {
			memset(bc->BotData,0,sizeof(SWR_DATA));
			SWR_DATA *z = (SWR_DATA*)bc->BotData;
			z->MapCoords = NULL;
		}
		break;
	case BOTCMD_FlagSet:
		FlagSet(bc,bm);
		break;
	case BOTCMD_MapName:
		EnteredArena(bc,bm);
		break;
	case BOTCMD_Tick:
		Tick(bc,bm);
		break;
	case BOTCMD_FlagPickup:
		FlagPickup(bc,bm);
		break;
	case BOTCMD_FlagReset:
		FlagReset(bc,bm);
		break;
	case BOTCMD_PlayerEntering:
		if (!strcmpi(bc->UserData->Name,"Mine GO BOOM") || !strcmpi(bc->UserData->Name,"ShadowRipper")) {
			SWR_DATA *z = (SWR_DATA*)bc->BotData;
			bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"BotOp logged in. Currently loading coords off '%s'",z->BMPName);
			bc->UserData->OpLevel=1;
		}
		break;
	case BOTCMD_FlagDrop:
		if (bc->Data1>-1) {
			SWR_DATA *z = (SWR_DATA*)bc->BotData;
			strcpy(z->Flags[bc->Data1].Name,bc->UserList[bc->Flags[bc->Data1].PUID].Name);
		}
		break;
	case BOTCMD_Kill:
		//If the flag is dropped off the kills, the core will handle that by sending us a FlagDrop..
		if (bc->Data2) {
			//A flag was transfer through the kills...
			SWR_DATA *z = (SWR_DATA*)bc->BotData;
			int c;
			for (c=0;c<MAX_FLAGS;c++) {
				if (bc->Flags[c].Exists && bc->Flags[c].Carried && bc->Flags[c].PUID == bc->Killer->UID) {
					//The killer has this flag, so lets update our local name for who has the flag..
					strcpy(z->Flags[c].Name,bc->Killer->Name);
				}
			}
		}
		break;
	case BOTCMD_Disconnect:
		Disconnect(bc,bm);
		break;
	case BOTCMD_Line:
		if (bc->Line->LineType==LINETYPE_PRIVATE) {
			SWR_DATA *z = (SWR_DATA*)bc->BotData;
			if (!strcmpi(bc->Line->CmdStr,"!help")) {
				bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"!help      - Displays all commands");
				bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"!info      - Displays info about this bot");
				if (bc->UserData->OpLevel) {
					bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"!flags     - Displays info about flags");
					bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"!go        - Changes arena");
					if (z->MapCoords == NULL) {
						bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"!reload    - Will re-load the %s that it has locally (currently not loaded)",z->BMPName);
					} else {
						bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"!reload    - Will re-load the %s that it has locally",z->BMPName);
					}
					bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"!refresh   - Will do a *getfile %s to refresh BMP Coords info",z->BMPName);
				}
			} else if (!strcmpi(bc->Line->CmdStr,"!flags") && bc->UserData->OpLevel) {
				int c;
				for (c=0;c<MAX_FLAGS;c++) {
					if (bc->Flags[c].Exists) {
						int i=BMPTestCoord(bc,bm,bc->Flags[c].XCoord,bc->Flags[c].YCoord);
						bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"Flag %d at %d,%d with tile: %d [Outside: %d]",c,bc->Flags[c].XCoord,bc->Flags[c].YCoord,i,z->FlagOutside[c]);
						if (i == 255 || i == -1) {
							z->FlagOutside[c]=1;
						} else {
							z->FlagOutside[c]=0;
						}
					}
				}
			} else if (!strcmpi(bc->Line->CmdStr,"!coords")) {
				int i=BMPTestCoord(bc,bm,CtT(bc->UserData->XCoord),CtT(bc->UserData->YCoord));
				bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"You are located on tile: %d  (%d,%d)",i,CtT(bc->UserData->XCoord),CtT(bc->UserData->YCoord));
			} else if (!strcmpi(bc->Line->CmdStr,"!info")) {
				bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"Bot Name: %s   Bot Version: %s (Header: %s)   Maker: %s (%s)",bc->BotInfo[bc->BehaviorID].DllInfo->Name,bc->BotInfo[bc->BehaviorID].DllInfo->Version,bc->BotInfo[bc->BehaviorID].DllInfo->HeaderVersion,bc->BotInfo[bc->BehaviorID].DllMaker->Name,bc->BotInfo[bc->BehaviorID].DllMaker->Email);
				bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"Description: %s",bc->BotInfo[bc->BehaviorID].DllInfo->Info);
				bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"BotCore information: This bot is running off the bot core named CEBot, which was created by Mine GO BOOM.");
				bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"  This bot core is currently under testing, this dll being its first real life test.");
			} else if (!strcmpi(bc->Line->CmdStr,"!go") && bc->UserData->OpLevel) {
				ChangeArenas(bc,bm,bc->Line->Params);
			} else if (!strcmpi(bc->Line->CmdStr,"!reload") && bc->UserData->OpLevel) {
				bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"LoadBMP returned: %d",LoadBMP(bc,bm));
			} else if (!strcmpi(bc->Line->CmdStr,"!refresh") && bc->UserData->OpLevel) {
				bm->SendTextMessage(bc,LINETYPE_PUBLIC,0,0,"*getfile %s",z->BMPName);
				bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"Doing *getfile %s now...",z->BMPName);
			}
		}
		break;
	}
}

int LoadBotName(BOT_NAMES *bn) {
	memset(bn,0,sizeof(BOT_NAMES)*MAX_DLLS);
	int i=0,l,c;
	char str[255];
	FILE *f = fopen(BOT_NAME_FILE,"r");
	if (f!=NULL) {
		while (!feof(f)) {
			fgets(str,255,f);
			l=strlen(str)-1;
			if (str[l]=='\n') str[l]=0;
			l=strlen(str);
			int step=0;
			int last=0;
			for (c=0;c<l;c++) {
				if (str[c]==':') {
					str[c]=0;
					if (step == 0) {
						strcpy(bn[i].BotName,&str[last]);
					} else if (step == 1) {
						strcpy(bn[i].Password,&str[last]);
					} else if (step == 2) {
						strcpy(bn[i].IP,&str[last]);
						bn[i].Port = atoi(&str[c+1]);
						bn[i].Arena[0]=0;
						bn[i].ArenaType=ARENATYPE_Random;
						i++;
						break;
					}
					step++;
					last=c+1;
				}
			}
		}
	}
	if (i>MAX_DLLS) i=MAX_DLLS;
	return i;
}

int LoadBMP(BOT_CMD *bc,BOT_MSG *bm) {
	SWR_DATA *z = (SWR_DATA*)bc->BotData;
	if (z->MapCoords != NULL) {
		free(z->MapCoords);
		z->MapCoords=NULL;
	}
	z->MapCoords = malloc(1048576);
	if (z->MapCoords == NULL)
		return -4;
	if (strlen(z->BMPName)==0)
		return -1;
	FILE *f = fopen(z->BMPName,"rb");
	if (f==NULL)
		return -2;
	char buff[255];
	int i = fread(buff,sizeof(char),sizeof(BITMAPFILEHEADER),f);
	BITMAPFILEHEADER *bh = (BITMAPFILEHEADER*)buff;
	if (!bh->bfType)
		return -3;
	fseek(f,bh->bfOffBits,SEEK_SET);
//	char p[1048576];
//	for (int c=0;c<1048576;c++)
//		p[c] = fgetc(f);
	i = fread(z->MapCoords,sizeof(char),1048576,f);
	fclose(f);
//	memcpy(z->MapCoords,&p,1048576);
	return i;
}

char BMPTestCoord(BOT_CMD *bc,BOT_MSG *bm,int XCoord,int YCoord) {
	/*
	BITMAPFILEHEADER bmfh;
	BITMAPINFOHEADER bmih;
	RGBQUAD          aColors[];
	BYTE             aBitmapBits[];
	*/

	///*	Use z->MapCoords
	SWR_DATA *z = (SWR_DATA*)bc->BotData;
	if (z->MapCoords == NULL)
		return -3;
//	int i;
//	i=CtO(XCoord,YCoord);
//	char *p = (char*)z->MapCoords;
//	i = p[CtO(XCoord,YCoord)];
//	i=((char*)z->MapCoords)[CtO(XCoord,YCoord)];
	return (((char*)z->MapCoords)[CtO(XCoord,YCoord)]);
//	return i;
	//*/


	/*	Load map
	SWR_DATA *z = (SWR_DATA*)bc->BotData;
	if (strlen(z->BMPName)==0)
		return -2;
	FILE *f = fopen(z->BMPName,"rb");
	if (f==NULL)
		return -1;
	char buff[255];
	int i = fread(buff,sizeof(char),sizeof(BITMAPFILEHEADER),f);
//	BMPHead *bh = (BMPHead*)buff;
	BITMAPFILEHEADER *bh = (BITMAPFILEHEADER*)buff;
	if (!bh->bfType)
		return -3;
//	if (strcmp(bh->title,"BM"))
//		return -2;
	fseek(f,bh->bfOffBits + CtO(XCoord,YCoord),SEEK_SET);
	int tile;
	tile = fgetc(f);
	fclose(f);
//	bm->SendTextMessage(bc,LINETYPE_PUBLIC,0,0,"Offset: %d(%d)  Size: %d  X,Y: %d,%d  Tile: %d",bh->bfOffBits,bh->bfOffBits + CtO(XCoord,YCoord),bh->bfSize,XCoord,YCoord,tile);

	return tile;	//for testing reasons, will just print back every number..
	//*/

/*
	if (tile == 255) {	//The last color in the pallet, means this is an invalid spot
		return 1;
	} else {
		return 0;
	}
//*/
}

void FindEmptyName(BOT_CMD *bc,BOT_MSG *bm) {
	BOT_NAMES bn[MAX_DLLS];
	int bmax=LoadBotName(bn);
	int ours=-1;
	int bused[MAX_DLLS];
	int c,i;
	for (c=0;c<MAX_DLLS;c++) {
		bused[c]=0;
		if (bc->BotInfo[c].BotStatus->IsValid && c != bc->BehaviorID) {
			if (bc->BotInfo[c].BotStatus->DllID == bc->BotInfo[bc->BehaviorID].BotStatus->DllID) {
				for (i=0;c<bmax;c++) {
					if (!strcmpi(bc->BotInfo[c].BotStatus->BotName,bn[i].BotName)) {
						bused[i]=1;
						break;
					}
				}
			}
		}
	}
	for (c=0;c<bmax;c++) {
		if (!bused[c]) {
			ours = c;
			break;
		}
	}
	/*
	strcpy(bn[ours].Arena,"Update6");
	bn[ours].ArenaType=ARENATYPE_Private;
	//*/
	///*
	strcpy(bn[ours].Arena,"tals");
	bn[ours].ArenaType=ARENATYPE_Private;
	//*/
	/*
	strcpy(bn[ours].Arena,"");
	bn[ours].ArenaType=ARENATYPE_Random;
	//*/
	if (ours > -1) {
		bm->SendEnterZone(bc,bn[ours].IP,bn[ours].Port,bn[ours].BotName,bn[ours].Password,bn[ours].Arena,bn[ours].ArenaType,16,1);
	} else {
		bm->SendShutdown(bc);
	}
}

void FlagSet(BOT_CMD *bc,BOT_MSG *bm) {
	SWR_DATA *z = (SWR_DATA*)bc->BotData;
//	z->FlagOutside[bc->Data1] = BMPTestCoord(z->BMPName,bc->Flags[bc->Data1].XCoord,bc->Flags[bc->Data1].YCoord);
	int c=BMPTestCoord(bc,bm,bc->Flags[bc->Data1].XCoord,bc->Flags[bc->Data1].YCoord);
	if (c == 255 || c == -1) {
		z->FlagOutside[bc->Data1]=1;
	} else {
		z->FlagOutside[bc->Data1]=0;
	}
}

void FlagPickup(BOT_CMD *bc,BOT_MSG *bm) {
	SWR_DATA *z = (SWR_DATA*)bc->BotData;
	z->FlagOutside[bc->Data1]=0;
}

void FlagReset(BOT_CMD *bc,BOT_MSG *bm) {
	SWR_DATA *z = (SWR_DATA*)bc->BotData;
	memset(&z->FlagOutside,0,MAX_FLAGS);
}

void EnteredArena(BOT_CMD *bc,BOT_MSG *bm) {
	SWR_DATA *z = (SWR_DATA*)bc->BotData;
	int c,l;
	strcpy(z->BMPName,bc->DataC);
	l=strlen(z->BMPName);
	for (c=0;c<l;c++) {
		if (z->BMPName[c]=='.') {
			z->BMPName[c]=0;
			strcat(z->BMPName,".bmp");
		}
	}
	z->LastGrab=GetTickCount();
	bc->iTickDelay=50;
	LoadBMP(bc,bm);
	c=BMPTestCoord(bc,bm,0,0);
	if (c<0) {
//		bm->SendTextMessage(bc,LINETYPE_PUBLIC,0,0,"*getfile %s",z->BMPName);
	}
	for (c=0;c<MAX_FLAGS;c++) {
		if (bc->Flags[c].Exists && !bc->Flags[c].Carried) {
			BMPTestCoord(bc,bm,bc->Flags[c].XCoord,bc->Flags[c].YCoord);
		}
	}
}

void Tick(BOT_CMD *bc,BOT_MSG *bm) {
	SWR_DATA *z = (SWR_DATA*)bc->BotData;
	int c;
	for (c=0;c<MAX_FLAGS;c++) {
		if (z->FlagOutside[c] && bc->Flags[c].Exists && !bc->Flags[c].Carried) {
			if (GetTickCount() - z->LastGrab > FLAG_DELAY_TIME) {
				if (bc->UserList[bc->iMyUID].Shiptype) {
					bm->SendPickupFlag(bc,c);
//					bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->iMyUID,0,"*spec");
					bm->SendChangeShips(bc,0);
					z->FlagOutside[c]=0;
					LogFlagDrop(bc,bm,z->Flags[c].Name,bc->Flags[c].XCoord,bc->Flags[c].YCoord);
					if (strlen(z->Flags[c].Name)) {
						bm->SendTextMessage(bc,LINETYPE_PUBLIC,0,0,"*arena Flag dropped by %s was found outside, and has been neutraled back to the middle",z->Flags[c].Name);
					} else {
						bm->SendTextMessage(bc,LINETYPE_PUBLIC,0,0,"*arena Flag was found outside, and has been neutraled back to the middle");
					}
					z->LastGrab=GetTickCount();
				} else {
//					bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->iMyUID,0,"*setship 1");
					bm->SendChangeShips(bc,1);
					z->LastGrab = GetTickCount() - FLAG_DELAY_TIME/2;
				}
			}
			break;
		}
	}
}

void LogFlagDrop(BOT_CMD *bc,BOT_MSG *bm,char *Name,short X,short Y) {
	FILE *f = fopen(FLAG_DROP_LOG,"a+");
	if (f==NULL)
		return;
	if (strlen(Name))
		fprintf(f,"Player '%s' dropped a flag at %d,%d\n",Name,X,Y);
	else
		fprintf(f,"A flag found outside, dropped by an unknown person, was at %d,%d\n",X,Y);
	fclose(f);
//	bm->SendTextMessage(bc,LINETYPE_PUBLIC,0,0,"*putfile %s",FLAG_DROP_LOG);
}

int ChangeArenas(BOT_CMD *bc,BOT_MSG *bm,char *ArenaName) {
	int ArenaType;
	if ((ArenaName[0] >= 48 || ArenaName[0] <= 57) && strlen(ArenaName)==1) {
		ArenaType=ARENATYPE_Public;
	} else if (strlen(ArenaName)==0) {
		ArenaType=ARENATYPE_Random;
	} else {
		ArenaType=ARENATYPE_Private;
	}
	char Name[20];
	strcpy(Name,bc->UserData->Name);
	switch (bm->SendChangeArenas(bc,ArenaName,ArenaType)) {
			//Params: BOT_CMD *bc,char *Arena,int ArenaType
	case BOTERROR_InvalidTiming:
		bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"Could not change arenas because of invalid timing");
		break;
	case BOTERROR_NoData:
		bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"Could not change arenas because there was no arena name labeled when trying to change to a non-random arena,");
		break;
	case BOTERROR_BadData:
		bm->SendTextMessage(bc,LINETYPE_PRIVATE,bc->UserData->UID,0,"Could not change arenas because arena name was too long");
		break;
	default:
		if (ArenaType==ARENATYPE_Private) {
			bm->SendTextMessage(bc,LINETYPE_CROSSZONE,0,0,":%s:Successfully change arenas to private arena %s",Name,ArenaName);
		} else if (ArenaType==ARENATYPE_Public) {
			bm->SendTextMessage(bc,LINETYPE_CROSSZONE,0,0,":%s:Successfully change arenas to public arena (Public %s)",Name,ArenaName);
		} else {
			bm->SendTextMessage(bc,LINETYPE_CROSSZONE,0,0,":%s:Successfully change arenas to a random public arena",Name);
		}
		break;
	}
	return 0;
}

int Disconnect(BOT_CMD *bc,BOT_MSG *bm) {
	SWR_DATA *z = (SWR_DATA*)bc->BotData;
	if (z->MapCoords != NULL) {
		free(z->MapCoords);
	}
	return 0;
}